@import "_fonts";
@import "_settings";

/*Global Resets*/
* { margin: 0; padding: 0; }
/* clearfix hack after Cederholm (group class name) */
.group:after {
    content: "";
    display: table;
    clear: both;
}
html, body {
    overflow-x: hidden;
    height: 100vh;
    scroll-behavior: smooth;
}
/*First significant deviation from CSS on tufte.css site - variable font size as browser width expands or contracts
html { font-size: 15px; }
*/
html{

    background-color: $bg-color;
    text-align: baseline;
    font-size: calc( 0.2vw + 12px  );
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
}

a {
 color: #786452;
 text-decoration: none;
}

a:active, a:hover {
 color: $contrast-color;
 text-decoration: none;
}

p > a, cite > a, span > a {

    @if $link-style == underline
    {
        color: $text-color;
        text-decoration: none;
        background:
            -webkit-linear-gradient($bg-color, $bg-color),
            -webkit-linear-gradient($bg-color, $bg-color),
            -webkit-linear-gradient(currentColor, currentColor);

        background:
            linear-gradient($bg-color, $bg-color),
            linear-gradient($bg-color, $bg-color),
            linear-gradient(currentColor, currentColor);

        -webkit-background-size: 0.05em 1px, 0.05em 1px, 1px 1px;
        -moz-background-size:    0.05em 1px, 0.05em 1px, 1px 1px;

        background-size:   0.05em 1px, 0.05em 1px, 1px 1px;
        background-repeat: no-repeat, no-repeat, repeat-x;
        text-shadow:
            0.03em  0 $bg-color,
            -0.03em 0 $bg-color,
            0 0.03em $bg-color,
            0 -0.03em $bg-color,
            0.06em  0 $bg-color,
            -0.06em 0 $bg-color,
            0.09em  0 $bg-color,
            -0.09em 0 $bg-color,
            0.12em  0 $bg-color,
            -0.12em 0 $bg-color,
            0.15em  0 $bg-color,
            -0.15e  0 $bg-color;
        background-position: 0% 93%, 100% 93%, 0% 93%;
    }
    @else
    {
        color: $contrast-color;
        text-decoration: none;
    }
}

main {
 width: 87.5%;
 margin-left: auto;
 margin-right: auto;
 padding-left: 12.5%;
 font-family: $body-font;
 background-color: $bg-color;
 color: $text-color;
 max-width: 1400px;
 counter-reset: sidenote-counter;
}

/*============================================================================
 Typography
==============================================================================*/

.header {
    color:#833231;
    //font-style: italic;
    //font-weight: bold ; //changed from 400 to 700 margin-top: 1.866666666666667rem;
    margin-top: 4rem;
    margin-bottom: 1rem;
    font-size: 2.8rem;
    line-height: 0.933333333333333;
}


h1 { @extend .header; }
h2 {
    @extend .header;
    font-size: 2.2rem;
    font-weight: 500;
}

h3,h4 {
    //font-style: italic;
    font-weight: 500; //changed from 400 to 700 margin-top: 1.866666666666667rem;
    margin-top: 2rem;
    margin-bottom: 2rem;
    font-size: 1.7rem;//2.1rem;
    line-height: 0.933333333333333;
}

p .subtitle {
    font-style: italic;
    margin-top: 2.1777777777777778rem;
    margin-bottom: 2.1777777777777778rem;
    font-size: 1.8rem;
    display: block;
    line-height: 1.08888888888889;
}


p, ol, ul { font-size: 1.4rem; }

p, li { line-height: 2rem;
        margin-top: 1.4rem;
        padding-right: 2rem; //removed because,  why?
        vertical-align: baseline; }

/* Epigraphs */
div.epigraph { margin: 3.5636rem 0; }

div.epigraph > blockquote
{
    margin-top: 3rem;
    margin-bottom: 3rem;
}

div.epigraph > blockquote, div.epigraph > blockquote > p { font-style: italic; }

div.epigraph > blockquote > footer
{
    font-style: normal;
    width: 45%;
    padding-left: 2.5%;
    padding-right: 2.5%;
    padding-top: 0;
    margin-top: 0.4455rem;
    margin-bottom: 3.1182rem;
}

div.epigraph > blockquote > footer > cite { font-style: italic; }
/* end chapter epigraphs styles */

blockquote p, blockquote footer
{
    width: 45%;
    padding-left: 2.5%;
    padding-right: 2.5%;
}

blockquote footer
{

    font-size: 1.1rem;
    line-height: 1.78181818;
    margin-top: 1.78181818rem;
    margin-bottom: 1.78181818rem;
    text-align: right;
}

/* blockquote footer { width: 45%;
                    text-align: right; }
*/

.sans
{
    font-family: $sans-font;
    letter-spacing: .03em;
}

p code
{
    font-family: $code-font;
    // removed .code 'class' since code is an actual html tag
    font-size: 0.92rem;
    // also added p code, p pre code and pre selector to account for Markdown parsing
    line-height: 1.71428571;
    // of triple backticks plus rationalized line-heights and margins
    margin-top: 1.71428571rem;
}

pre, pre code, p pre code
{

    font-family: $code-font;
    font-size: 0.92rem;
    line-height: 1.71428571;
    margin-top: 1.71428571rem;
    padding: 0 !important;
    padding-left: 1rem !important;
    padding-top: 1.5rem !important;
    padding-bottom: 1.5rem !important;
}


li code, p code, td code {
    color: #5b3910;
    padding: .2rem;
    border-radius: .2rem;
    /* border-style: solid; */
    /* border-width: 1px; */
    border-color: #c3bebe;
    background-color: #796a6a12;
    font-size: 1rem !important;
    width: 60%;
}
h1 code, h2 code, h3 code { font-size: 0.80em; }



/*====================================================================================
 Table style
====================================================================================== */

table, table.booktabs
{
    width: auto;
    margin-top: 1rem;
    margin-bottom: 2rem;
    border-spacing: 0px;
    border-top: 1px solid $border-color;
    border-bottom: 1px solid $border-color;
    border-collapse:separate;
    border-spacing: 0 0.5em;
}

.booktabs th, th
{
    border-bottom: 1px solid $border-color;
    font-weight: normal;
    font-style: italic;
    padding-right: 1.4rem;
}

th, td
{
    font-size: 1.2rem;
    line-height: 1.71428571;
}

td code
{

    font-size: 0.9rem !important;
}

.booktabs th.cmid, th
{
    border-bottom: 1px solid lighten($border-color, 25%);
}

.booktabs th.nocmid
{
    border-bottom: none;
}

.booktabs tbody tr:first-child td,  tr:first-child td
{
    padding-top: 0.65ex;
}

.booktabs td, td
{
    padding-left: 0.5em;
    padding-right: 0.5em;
    text-align: left;
    min-width: 1.4rem;
}

.booktabs caption, caption
{
    font-size: 90%;
    text-align: left;
    width: auto;
    margin-left: auto;
    margin-right: auto;
    margin-top: 1ex;
    caption-side: top;
}

.booktabs tbody tr, .booktabs thead tr th.l, .booktabs td.l { text-align: left   !important; }
.booktabs tbody tr, .booktabs thead tr th.c, .booktabs td.c { text-align: center !important; }
.booktabs tbody tr, .booktabs thead tr th.r, .booktabs td.r { text-align: right  !important; }

.table-caption
{
    float:right;
    clear:right;
    margin-right: -60%;
    width: 50%;
    margin-top: 0;
    margin-bottom: 0;
    font-size: 1.0rem;
    line-height: 1.96;
}

/*===============================================================================
 Basic Layout stuff
================================================================================*/

article
{
    position: relative;
    padding: 1 rem 0rem 2.5rem 0rem;
}

section
{
    padding-top: 1rem;
    padding-bottom: 1rem;
}

ul,ol
{
    width: 48%;
    -webkit-padding-start: 3%;
    -webkit-padding-end: 5%;
    list-style-type: none;
}

//li { padding: 0.5em 0; } //vertical padding on list items screws up vertical rhythym


figure, figure img.maincolumn
{
    -webkit-margin-start: 0;
    -webkit-margin-end: 0;
    margin-bottom: 3em;
}

figcaption
{
    float: right;
    clear: right;

    margin-right: -50%;
    margin-top: 0;

    margin-bottom: 0;
    font-size: 1.0rem;

    line-height: 1.6;
    vertical-align: baseline;

    position: relative;
    max-width: 40%;
}

figure.fullwidth figcaption
{
    float: left;
    margin-right: 0%;
    margin-left: 33%;
    max-width: 100%;
}

img {

    max-width: var( --img-width );
}

.sidenote, .marginnote
{
    float: right;
    clear: right;
    margin-right: -60%;
    width: 50%;
    margin-top: 0;
    margin-bottom: 1.96rem;

    font-size: 1.0rem;
    line-height: 1.96;

    vertical-align: baseline;
    position: relative;

    > img { width: 100%; }
}


li .sidenote, li .marginnote
{
    margin-right: -80%;
}

blockquote .sidenote, blockquote .marginnote
{
    margin-right: -79%
}

.sidenote-number
{
    counter-increment: sidenote-counter;
}

.sidenote-number:after, .sidenote:before
{
    content: counter(sidenote-counter) " ";
    font-family: $body-font;
    color: $contrast-color; //added color
    position: relative;
    vertical-align: baseline;
}

.sidenote-number:after
{
    content: counter(sidenote-counter);
    font-size: 1rem;
    top: -0.5rem;
    left: 0.1rem;
}

.sidenote:before
{
    // this is unicode for a non-breaking space
    content: counter(sidenote-counter) ".\000a0";
    color: $contrast-color;
    top: 0rem;
}

p, footer, div.table-wrapper,  .MJXc-display
{
    width: 55%;
}

div.table-wrapper, table
{
    overflow-x: auto;
}

@media screen and (max-width: 760px)
{
    p, footer     { width: 90%;     }
    pre code      { width: 87.5%;   }
    ul            { width: 85%;     }
    figure        { max-width: 90%; }
    figcaption,
    figure.fullwidth figcaption
    {
        margin-right: 0%;
        max-width: none;
    }
    blockquote p,
    blockquote footer,
    div.epigraph > blockquote > footer,.MJXc-display
    {
        width: 80%;
        padding-left: 5%;
        padding-right: 5%;

    }
}

.marginnote code, .sidenote code
{
    font-size: 1rem;
}

pre
{
    width: 52.5%;
    padding:4%;
    padding-left: 2.5%;
    overflow-x: auto;
}

.fullwidth, li.listing div
{
    max-width: 90%;
}

.full-width
{
    .sidenote,
    .sidenote-number,
    .marginnote
    {
        display: none;
    }
}

span.newthought
{
    font-variant: small-caps;
    font-size: 1.2em;
    letter-spacing: 0.05rem;
}

input.margin-toggle   { display: none; }

label.sidenote-number { display: inline; }

label.margin-toggle:not(.sidenote-number) { display: none; }

@media (max-width: 760px)
{


    label.margin-toggle:not(.sidenote-number) { display: inline; color: $contrast-color; }
    .sidenote, .marginnote { display: none; }
    .margin-toggle:checked + .sidenote,
    .margin-toggle:checked + .marginnote
    {
        display: block;
        float: left;
        left: 1rem;
        clear: both;
        width: 95%;
        margin: 1rem 2.5%;
        vertical-align: baseline;
        position: relative;
    }
    label { cursor: pointer; }
    pre, pre code, p code, p pre code
    {
        width: 90%; padding: 0;
    }

    .table-caption
    {
        display: block;
        float: right;
        clear: both;
        width: 98%;
        margin-top: 1rem;
        margin-bottom: 0.5rem;
        margin-left: 1%;
        margin-right: 1%;
        vertical-align: baseline;
        position: relative;
    }

    div.table-wrapper, table, table.booktabs
    {
        width: 85%;
    }
    div.table-wrapper
    {
        border-right: 1px solid red;
    }
    img { max-width: 100%; }
    figcaption.maincolumn-figure, figure.fullwidth figcaption
    {
        float:none;
        text-align: center;
    }
    figure.fullwidth figcaption
    {
        margin-left: 0;
    }

}


//==============================================================================
// Hugo Styling
//===============================================================================
:root {

    --spacing-col:2em;
    --hr-width: 0.54hw;
    --hr-height: 0.1em;
    --img-width: 70vw;
}

/*
 Horizontal Rule Styling
 =======================
 Two problems with using the hr tag. First, there is no reliable way
 to snap it on an element. Second, because of subpilxel rendering[1],
 when applying a solid line style, hr occasionally gets rendered
 with gaps in between.

 Here, an alternative approach is used.

-  Instead of using hr,  the class .hr and hrs are defined.
   The former will apply border style only to the bootom part of an element,
   while the other is applied to the element top as well.
 - To avoid rendering artificat, it uses border-height and background color
   to style the hr
   and hrs style.

References:
[1] https://stackoverflow.com/questions/50371645/some-hr-tags-have-gaps-inside-them-while-other-doesnt
*/
.hrs {
    display: inline-block;
}
.hrs:after {
    content: '';
    display: block;

    margin-top:    2%;
    margin-bottom: 2%;
    background-color: #b3706b;
    padding: 0px;
    height: var( --hr-height );
    border-width: 0px;
    border-radius: 0px;
    border-style: solid;
}

.hrs:before {
    content: '';
    display: block;
    margin-top:    2%;
    margin-bottom: 2%;
    background-color: #b3706b;
    padding: 0px;
    height: var( --hr-height );
    border-width: 0px;
    border-radius: 0px;
    border-style: solid;
}
@media (max-width: 760px) {

    .hrs { width:90% !important; }
}

.hr {
    display: inline-block;
}

.hr:after {
    content: '';
    display: block;
    margin-top:   2%;
    margin-bottom: 2%;
    background-color: #b3706b;
    padding: 0px;
    height: var(--hr-height);
    border-width: 0px;
    border-radius: 0px;
    border-style: solid;
}

/*
========================================================================================
Hugo callout element
========================================================================================

A callout element is makred with a top and bottom
horizontal rule.

 ------------------

     [CONTENT]

 ------------------
The conet should be aligned with the rest of content
element. Tufte CSS takes care of positioning the element
for us. However, it does not constrain top level elements.
Further, it applies a bit too much indentation on list
elements.
*/
#hugo-callout {
    width:56%;
    font-size: 1.6rem;
}

@media screen and (max-width: 760px ) {
    #hugo-callout {
        width:86%;
    }
}

/*
=================================================================================
 Home Page Style
==================================================================================
*/

section.home-posts {

    h1
    {
        font-style: italic;
        font-weight: lighter !important;
        font-size: 2.8rem;
    }


    ul { width: 100%; }
    ul > li > article > h2 {
        font-family: $sans-font;
        font-style: normal;
        font-weight: lighter;
        opacity: 60%;
    }

    ul > li > article > div >  h2 {

        font-family: $body-font;
        font-style: italic;
        font-size: 2rem;
        font-style: normal;
        padding: 0;
        margin: 0;
        opacity:100%
    }

    ul > li > article > div > h2 > a {
        font-size:1.8rem;
        font-weight: bold;
        color:$contrast-color;
    }

    ul > li > article > div > p > a {
        font-size:1.6rem;
        margin-left: 1rem;
    }


    ul > li > article {
        margin-bottom: var(--spacing-l);
    }


    @media (min-width: 600px)
    {
        ul > li > article
        {
            display: grid;
            width: 100%;
            grid-template-columns: clamp(8em, 30vw, var(--spacing-col)) 1fr;
            align-items: baseline;
            margin-bottom: var(--spacing-s);
        }

    }
}


.tiles {
    display: grid;
    width: 50%;
    grid-template-columns: 1fr 1fr 1fr;
    margin-top:1rem;
}


.tile {

    margin:0;
    padding: 0;
    font-family:$sans-font;
    text-align: left;
    min-width: 100px;
}

// language badges
.lang-badges {
    display: contents;
    padding: 0;
    img { object-fit: contain; min-height:1.5rem; }
}

// Projects Section
// This section will display a list of projects
// Each project displays
// - Publish date
// - Project Title
// -
.project-pubdate {

    font-weight: normal;
    font-style: normal;
    font-size: 1rem
}

#tocw { }

#TableOfContents ul
{
    padding-top:8%;
    width: 25%;
    float: right;
}

#TableOfContents li
{
    font-family: $sans-font;
    font-size: 1.4rem;
}
@media screen and (max-width: 1400px)
{
    #TableOfContents { display:none; }
}

// Article Header
header.hugo-post-header
{
    > section {
        padding:0;
        margin:0;
        padding-top:0%;
    }

    > section > h1
    {
        margin-top: 5%;
        font-weight: 600 !important;
        font-size: calc( 1.4vw + 18px);
        width: 45vw;
        text-align: left;
        margin-bottom: 1rem;
        line-height:4 rem;
    }

    > section > aside {
        width: 72vw;
        margin-top: 2rem;
        margin-bottom: 1rem;
    }

    > section > aside > ul
    {
        padding: 0;
        padding-left:2%;
        width: 80%;
        text-align: left;
    }

    > section > aside >  ul > li
    {
        padding: 0;
        margin: 0;
        display: inline;
        font-size: 1rem;
        font-family: $sans-font;
        color:#9b9696;
    }

    > section > aside >  ul  li:not(:last-child):after
    {
        content: "|";
        color: grey;
        border-radius: 1ch;
        padding-inline: 1ch;
        margin-inline-end: 1ch;
    }


}

@media screen and (max-width: 1400px)
{

    header.hugo-post-header
    {
        > section > h1
        {
            text-align: center;
            width: 82vw;
            margin-bottom: 1rem;
            line-height: 5rem;
        }

    }
}






header.hugo-post-header section p#abstract
{

    border-style:solid;
    border-color:$border-color;
    border-width:0;
    border-top-width:1px;
    border-bottom-width:1px;

    padding: 0;
    padding-top:3%;
    padding-bottom:3%;
    margin-top:5% !important;
    margin-bottom:5% !important;
    text-align: justify;
}


.contrast
{
    color: $contrast-color;
}

.smaller {
    font-size: 80%;
}

// Navigation
header > nav.group, body footer
{
    width: 100%;
    padding: 1rem;
}

span[id=simfish]
{
    position: absolute !important;
    padding-left:4%;
    top: 2rem;
    color: $text-color;
    font-family: 'VT323', monospace;
    font-size:1.6rem;
}

header[id=topnav]
{
    position: sticky;
    top: 0px;
    z-index: 300;
    width: 100%;
    margin: 0px !important;
    background-color: $bg-color;
    border-style:solid;
    border-color:$border-color;
    border-width: 0;
    border-bottom-width:1px;
    nav.group { display: contents; }
    nav.group > ul
    {
        //background-color: yellow;
        margin-right: 17%;
        @media only screen and (max-width: 760px)
        {
            margin: 0 auto;
        }
        display: flex;
        padding:0px;
        width: fit-content;
        float: right;
    }
    nav.group > ul > li
    {
        font-family: $sans-font;
        font-size: 1rem;
        font-weight: 400;
        vertical-align: baseline;
        text-decoration: none;
        text-transform: capitalize;
        padding-bottom: 1.4rem;
    }
}

#main-content
{
    padding-top: 1%;
    flex: 1 0 auto;
}

footer
{
    margin: 0;
    margin-top: 12%;
    padding: 0 !important;
    flex-shrink: 0;
}

ul.footer-links, .credits{
    font-size:small;
    list-style: none;
    text-align: center;
    margin: 0 auto;
}

ul.footer-links li {

    display: inline;
    padding: 0.5rem 0.25rem;

}

ul.footer-links li:not(:last-child):after {
    content:'|';
}


.credits
{
    padding: 1rem 0rem;
}

//change font color for credit links in footer

.credits
{
    a{color: $contrast-color !important;}
    font-family: $sans-font;
    font-weight: lighter;
    opacity:0.55;
}


//Full width page styling stuff

// POSTS
ul.posts
{
    padding: 8%;
    padding-top:0;
}

li.post
{
    margin-bottom: 12%;
}

ul.posts > li.post > article > h1.subtitle
{
    width:100%;
    font-style: normal;
    font-size: 1.6rem;
    display: block;
    display: inline-block;
    line-height: 1.08888888888889;
}
ul.posts > li.post > article > h1.subtitle > div.post-url
{
    font-size:1rem;
    color:grey;
    font-style: italic;
    font-weight: normal;
    margin-top:0.7rem;
}

ul.posts > li.post > article > h1.subtitle > div.post-timestamp
{
    width: 100%;
    color: #713e3e;
    font-style: normal;
    font-weight: normal;
    font-size: 1rem;
}
ul.posts > li.post > article p.detail
{
    width:100%;
    display: block;
    display: inline-block;
    line-height: 1.08888888888889;
    color: dimgray;
    padding:0px;
    margin: 0px;
    margin-top:-1em;
    font-size: 1.4rem;
}

ul.posts > li.post > article p.detail > a {
    padding-left: 0.6rem;
    margin-left: 0.4rem;
    font-weight: normal;
}





body.full-width, .content-listing, ul.content-listing li.listing
{
    width: 90%;
    margin-left: auto;
    margin-right: auto;
    padding: 0% 5%;
}

.full-width article p
{
    width: 90%;
}


h1.content-listing-header
{
    font-style: normal;
    text-transform: uppercase;
    letter-spacing: 0.2rem;
    font-size: 1.8rem;
}

li.listing hr
{
    width:100%;
}

.listing, .listing h3
{
    display: inline-block;
    margin:0;
}
li.listing {
    margin:0;
    & p{
        width: 100%
    }
}


li.listing:last-of-type
{
    border-bottom: none;
    margin-bottom: 1.4rem;
}

li.listing h3.new
{
    text-transform: uppercase;
    font-style: normal;
}

hr.slender
{
    width:100% !important;
    border: 0;
    height: 1px;
    margin-top: 1.4rem;
    margin-bottom:1.4rem;
    background-image:
        -webkit-linear-gradient(left, rgba(0,0,0,0), rgba( #F2F2F2,0.75 ), rgba(0,0,0,0));
    background-image:
        -moz-linear-gradient(left,    rgba(0,0,0,0), rgba( #F2F2F2,0.75),  rgba(0,0,0,0));
    background-image:
        -ms-linear-gradient(left,    rgba(0,0,0,0),  rgba( #F2F2F2,0.75 ), rgba(0,0,0,0));
    background-image:
        -o-linear-gradient(left,     rgba(0,0,0,0),  rgba( #F2F2F2,0.75 ), rgba(0,0,0,0));
}

// Printing
@media screen
{
    .print-footer
    {
        display: none;
    }
}

@media print
{

    *
    {
        -webkit-transition: none !important;
        transition: none !important;
    }
    *,
    *:before,
    *:after
    {
        background: transparent !important;
        box-shadow: none !important;
        text-shadow: none !important;
    }
    @page
    {
        margin: 0.75in 0.5in 0.75in 0.5in;
        orphans:4; widows:2;
    }

    body
    {
        font-size:  12pt;

    }

    html body span.print-footer
    {
        font-family: $sans-font;
        font-size: 9pt;
        margin-top: 22.4pt;
        padding-top: 4pt;
        border-top: 1px solid #000;
    }

    thead
    {
        display: table-header-group;
    }

    tr,
    img
    {
        page-break-inside: avoid;
    }

    img
    {
        max-width: 100% !important;
    }

    p,
    h2,
    h3
    {
        orphans: 4;
        widows: 4;
    }
    article h2, article h2 h3, article h3, article h3 h4, article h4, article h4 h5
    {
        page-break-after: avoid;
    }

    body header , body footer
    {
        display:none;
    }
}

// citation
.csl-bib-body {
    width:65% !important;
    font-size:1.3rem;
    font-family: $sans-font;
}
.csl-left-margin {

    color: $contrast-color;
    font-weight: lighter;
}

/* =============================================================================
 * Filter
 * ============================================================================= */
.svg-icon {
    filter: invert(21%) sepia(50%) saturate(1303%) hue-rotate(324deg) brightness(95%) contrast(89%);
}
